<template>
  <TransitionGroup
    v-if="config && config.enabled"
    class="outer-container"
    name="leaderboard"
  >
    <div
      class="team-row"
      v-for="(team, index) in teamsSortedByScore"
      :key="team.id"
      :style="`background-color:${teamColorLookup[team.id]}`"
    >
      <div class="team-name">{{ index + 1 }} ) {{ team.teamName }}</div>
      <strong>{{ team.score }}</strong>
    </div>
  </TransitionGroup>
</template>

<script lang="ts">
import Vue from "vue";
import {
  ZoomSenseClientFirebaseDB,
  ZoomSenseConfigCurrentStatePlugins,
} from "@zoomsense/zoomsense-firebase";
import { ScoreEvents } from "./scoreEvent";
import { Team, Teams } from "./team";
import { scoreEventsReducer } from "./scoreEventsReducer";

const OPACITY = 1;
const TEAM_COLORS = [
  `rgba(50, 168, 82, ${OPACITY})`,
  `rgba(252, 186, 3, ${OPACITY})`,
  `rgba(66, 135, 245, ${OPACITY})`,
  `rgba(212, 74, 156, ${OPACITY})`,
];

export default Vue.extend({
  name: "UIDisplay",
  props: {
    firebase: {
      required: true,
      type: Object as () => ZoomSenseClientFirebaseDB,
    },
    context: {
      required: true,
      type: Object as () => { meetingid: string },
    },
  },
  data() {
    return {
      scoreEvents: undefined as undefined | ScoreEvents,
      teams: undefined as undefined | Teams,
      config: undefined as
        | undefined
        | ZoomSenseConfigCurrentStatePlugins["trivialeaderboardoverlay"],
      // Since we support the leaderboard being paused, we need somewhere to cache
      // the scores as they were when the leaderboard was paused
      teamScoresCache: undefined as undefined | Record<string, number>,
    };
  },
  computed: {
    // This is the total scores of the teams as calculated based on the
    // current state of the RTDB
    teamsTotalScores(): Record<string, number> | undefined {
      if (!this.scoreEvents || !this.teams) {
        return undefined;
      }
      return Object.values(this.scoreEvents).reduce(
        scoreEventsReducer,
        {} as Record<string, number>
      );
    },
    // "to render" in the name means that this is what we will show the user,
    // not necessarily what's in the database. This is to support pausing the
    // leaderboard
    teamsTotalScoresToRender(): Record<string, number> | undefined {
      if (this.config?.liveLeaderboardPaused) {
        return this.teamScoresCache;
      }
      return this.teamsTotalScores;
    },
    teamColorLookup(): Record<string, string> {
      if (!this.teams) {
        return {};
      }

      return Object.keys(this.teams).reduce((acc, teamId, index) => {
        acc[teamId] = TEAM_COLORS[index % TEAM_COLORS.length];
        return acc;
      }, {} as Record<string, string>);
    },
    teamsSortedByScore(): (Team & { id: string; score: number })[] {
      if (!this.teams) {
        return [];
      }
      return Object.entries(this.teams)
        .map(([teamId, team]) => ({
          id: teamId,
          score: this.teamsTotalScoresToRender?.[teamId] ?? 0,
          ...team,
        }))
        .sort((a, b) => b.score - a.score);
    },
  },
  watch: {
    config: {
      immediate: true,
      async handler(newConfig, previousConfig) {
        if (
          !previousConfig?.liveLeaderboardPaused &&
          newConfig?.liveLeaderboardPaused
        ) {
          this.teamScoresCache = this.teamsTotalScores;
        }
      },
    },
    teamsTotalScores: {
      immediate: true,
      async handler(newTeamsTotalScores, previousTeamsTotalScores) {
        if (!previousTeamsTotalScores) {
          this.teamScoresCache = newTeamsTotalScores;
        }
      },
    },
    firebase: {
      immediate: true,
      async handler() {
        await this.$typedRtdbBind(
          "config",
          this.firebase.ref(
            `config/${this.context.meetingid}/current/currentState/plugins/trivialeaderboardoverlay`
          )
        );

        await this.$typedRtdbBind(
          "scoreEvents",
          this.firebase.ref(
            `/data/plugins/trivialeaderboardoverlay/${this.context.meetingid}/scoreEvents`
          )
        );

        await this.$typedRtdbBind(
          "teams",
          this.firebase.ref(
            `/data/plugins/teamPlugin/${this.context.meetingid}`
          )
        );
      },
    },
  },
});
</script>
<style scoped>
.outer-container {
  gap: 1rem;
  display: flex;
  flex-direction: column;
  width: 24rem;
  position: absolute;
  top: 1rem;
  left: 1rem;
}

.team-row {
  display: flex;
  flex-direction: row;
  background-color: rgba(49, 224, 151, 0.3);
  padding: 10px 15px;
  border-radius: 10px;
  font-size: larger;
}

.team-name {
  flex-grow: 1;
  text-overflow: ellipsis;
  max-width: 19rem;
  white-space: nowrap;
  overflow: hidden;
  margin-right: 0.5rem;
}

/* Leaderboard animations */
.leaderboard-move,
.leaderboard-enter-active,
.leaderboard-leave-active {
  transition: all 0.5s ease;
}

.leaderboard-enter-from,
.leaderboard-leave-to {
  opacity: 0;
  transform: translateX(30px);
}

.leaderboard-leave-active {
  position: absolute;
}
</style>
